var isTitanium = typeof Ti !== "undefined";
var yaxisLabelCount = 0;
var lastFlotData = {};

var postDrawCb = function () {
    $("#graph .flot-y-axis").css("background-color", lastFlotData.options.colorGridBackground);
    var height = $("#graph").height();
    $("#graph .flot-y-axis").css("height", height);
    var yaxis = $("#graph .flot-y-axis").remove();
    $(".graphWrapper").prepend(yaxis);

    var width = $(".yAxis div:last-child").width();
    $(".yAxis").width(width + 5);
};

function drawGraph(e, graphHeight) {
    if (typeof XDate.setXDateLanguageId === "function") {
        XDate.setXDateLanguageId(e.languageId);
    }

    setElementDimensions(graphHeight);

    $(".graphWrapper .flot-y-axis").remove();


    if (e.wide) document.getElementById("graph").setAttribute("class", "wide");else document.getElementById("graph").setAttribute("class", "");

    var clone = $.extend(true, {}, e);
    clone.$container = $("#graph");
    window.consumption.flot(clone, postDrawCb);
}

if (isTitanium) {
    Ti.App.addEventListener("updateGraph", function (e) {
        lastFlotData = e;
        drawGraph(e);
    });

    Ti.App.addEventListener("updateGraphSize", function (e) {
        drawGraph(lastFlotData, e.height);
    });

    $("#graph").bind("plotclick", function (event, pos, item) {
        Ti.App.fireEvent("plotclick", {
            item: item
        });
    });

    window.onresize = function () {
        document.getElementById("graph").style.height = window.innerHeight + 'px';
    };
}

function pixelsToInt(pixels) {
    var temp = pixels.replace("px", "");
    return parseInt(temp);
}

var setElementDimensions = function (graphHeight) {
    if (graphHeight) window.innerHeight = graphHeight;

    var windowHeight = window.innerHeight - 1;
    var windowWidth = document.documentElement.clientWidth;

    $("#graph").css("height", windowHeight + "px");
    $("#graph").css("max-width", windowWidth + "px");
    $("body").css("max-width", windowWidth + "px");
    $("body").css("width", windowWidth + "px");
};

$(document).ready(function () {
    setElementDimensions();

    if (!isTitanium) {
        var args = {
            "yAxisMax": 1000,
            "yAxisMin": 0,
            "options": {
                "colorAverage": "#DD0011",
                "colorsConsumption": ["#50961E", "#B3D800"],
                "colorConsumptionHoliday": "#ABAEB0",
                "colorConsumptionIncomplete": "#449696",
                "colorConsumptionWeekend": "#ABAEB0",
                "colorExpected": "#DD7315",
                "colorGridBackground": "#ffffff",
                "colorGridFont": "#44484A",
                "showIncomplete": true
            },
            "languageId": "da-dk",
            "localeTable": {
                "da-dk": "dk",
                "de-ge": "de",
                "de-de": "de",
                "de-at": "de",
                "en-en": "us",
                "en-us": "us"
            },
            "numberFormat": "#,##0.##",
            "wide": true,
            "series": [{
                "data": [[0, 800.67], [1, 800.67], [2, 573.213], [3, 542.621], [4, 471.02199999999993], [5, 349.834], [6, 258.699], [7, 224.18199999999996], [8, 290.45099999999996], [9, 312.953], [10, 506.15199799999994], [11, 616.270997], [12, 739.78], [14, 739.78]],
                "color": "#50961E",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#B3D800",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 1
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 0], [1, 0], [2, 0], [3, 0], [4, 0], [5, 0], [6, 0], [7, 0], [8, 0], [9, 0], [10, 0], [11, 0], [12, 0], [14, 0]],
                "color": "#ABAEB0",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#ABAEB0",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 1
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 0], [1, 0], [2, 0], [3, 0], [4, 0], [5, 0], [6, 0], [7, 0], [8, 0], [9, 0], [10, 0], [11, 0], [12, 0], [14, 0]],
                "color": "#ABAEB0",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#ABAEB0",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 1
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 0], [1, 0], [2, 0], [3, 0], [4, 0], [5, 0], [6, 0], [7, 0], [8, 0], [9, 0], [10, 0], [11, 0], [12, 0], [14, 0]],
                "color": "#449696",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#449696",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 1
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 670.3789999999999], [1, 670.3789999999999], [2, 627.876], [3, 570.068], [4, 523.06], [5, 395.759], [6, 329.142], [7, 296.546], [8, 264.366], [9, 358.0560000000001], [10, 437.8740000000001], [11, 573.5139989999999], [12, 0], [14, 141.965]],
                "color": "#B3D800",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#50961E",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 2
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 0], [1, 0], [2, 0], [3, 0], [4, 0], [5, 0], [6, 0], [7, 0], [8, 0], [9, 0], [10, 0], [11, 0], [12, 0], [14, 0]],
                "color": "#ABAEB0",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#ABAEB0",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 2
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 0], [1, 0], [2, 0], [3, 0], [4, 0], [5, 0], [6, 0], [7, 0], [8, 0], [9, 0], [10, 0], [11, 0], [12, 0], [14, 0]],
                "color": "#ABAEB0",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#ABAEB0",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 2
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }, {
                "data": [[0, 0], [1, 0], [2, 0], [3, 0], [4, 0], [5, 0], [6, 0], [7, 0], [8, 0], [9, 0], [10, 0], [11, 0], [12, 141.965], [14, 141.965]],
                "color": "#449696",
                "label": "Forbrug (købt)",
                "bars": {
                    "show": true,
                    "fillColor": "#449696",
                    "barWidth": 0.45,
                    "lineWidth": 0,
                    "align": "center",
                    "order": 2
                },
                "lines": {
                    "show": false
                },
                "points": {
                    "show": false,
                    "symbol": "circle",
                    "radius": 4,
                    "lineWidth": 2
                }
            }],
            "xAxisLabels": ["Jan", "Feb", "Mar", "Apr", "Maj", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dec"],
            "xAxisMin": 0.5,
            "xAxisMax": 12.5
        };
        lastFlotData = args;
        drawGraph(args);
    }
});